
#include <sbkpython.h>
#include <shiboken.h>
#include <algorithm>
#include <signature.h>
#include "shiboken_python.h"



// Extra includes
#include "sbkversion.h"
#include "voidptr.h"

// Current module's type array.
Shiboken::Module::TypeInitStruct *SbkShibokenTypeStructs = nullptr;
// Backwards compatible structure with identical indexing.
PyTypeObject **SbkShibokenTypes = nullptr;
// Current module's PyObject pointer.
PyObject *SbkShibokenModuleObject = nullptr;
// Current module's converter array.
SbkConverter **SbkShibokenTypeConverters = nullptr;

// Global functions ------------------------------------------------------------
static PyObject *SbkShibokenModule_createdByPython(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.createdByPython";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: createdByPython(PyObject*)->bool
    if (true) {
        overloadId = 0; // createdByPython(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // createdByPython(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (createdbypython)]
            if (Shiboken::Object::checkType(pyArg)) {
                bool wasCreatedByPython = Shiboken::Object::wasCreatedByPython(reinterpret_cast<SbkObject *>(pyArg));
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &wasCreatedByPython);
            } else {
                PyErr_SetString(PyExc_TypeError, "You need a shiboken-based type.");
            }
            // END of custom code block [file: shibokenmodule.cpp (createdbypython)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_delete(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.delete";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: delete(PyObject*)
    if (true) {
        overloadId = 0; // delete(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // delete(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (delete)]
            if (Shiboken::Object::checkType(pyArg)) {
                Shiboken::Object::callCppDestructors(reinterpret_cast<SbkObject *>(pyArg));
            } else {
                PyErr_SetString(PyExc_TypeError, "You need a shiboken-based type.");
            }
            // END of custom code block [file: shibokenmodule.cpp (delete)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *SbkShibokenModule_disassembleFrame(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.disassembleFrame";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: disassembleFrame(PyObject*)->PyObject
    if (true) {
        overloadId = 0; // disassembleFrame(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // disassembleFrame(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (disassembleframe)]
            Shiboken::AutoDecRef label(PyObject_Str(pyArg));
            const char *marker = Shiboken::String::toCString(label);
            disassembleFrame(marker);
            Py_INCREF(Py_None);
            pyResult = Py_None;
            // END of custom code block [file: shibokenmodule.cpp (disassembleframe)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_dump(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.dump";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: dump(PyObject*)->const char*
    if (true) {
        overloadId = 0; // dump(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // dump(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (dump)]
            if (!Shiboken::Object::checkType(pyArg)) {
                pyResult = Shiboken::String::fromCString("Ordinary Python type.");
            } else {
                std::string str = Shiboken::Object::info(reinterpret_cast<SbkObject *>(pyArg));
                pyResult = Shiboken::String::fromCString(str.c_str());
            }
            // END of custom code block [file: shibokenmodule.cpp (dump)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_dumpTypeGraph(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.dumpTypeGraph";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: dumpTypeGraph(const char*)->bool
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 0; // dumpTypeGraph(const char*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        const char* cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        SBK_UNUSED(cppArg0)

        if (Shiboken::Errors::occurred() == nullptr) {
            // dumpTypeGraph(const char*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (dumptypegraph)]
            const bool ok = Shiboken::BindingManager::instance().dumpTypeGraph(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &ok);
            // END of custom code block [file: shibokenmodule.cpp (dumptypegraph)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_dumpWrapperMap(PyObject *self)
{
    SBK_UNUSED(self)
    static const char fullName[] = "Shiboken.dumpWrapperMap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // dumpWrapperMap()
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (dumpwrappermap)]
            Shiboken::BindingManager::instance().dumpWrapperMap();
            // END of custom code block [file: shibokenmodule.cpp (dumpwrappermap)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *SbkShibokenModule_getAllValidWrappers(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "Shiboken.getAllValidWrappers";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getAllValidWrappers()
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (getallvalidwrappers)]
            const auto setAll = Shiboken::BindingManager::instance().getAllPyObjects();
            PyObject* listAll = PyList_New(0);
            if (listAll == nullptr)
                return nullptr;
            for (auto *o : setAll) {
                if (o != nullptr) {
                    if (PyList_Append(listAll, o) != 0) {
                        Py_DECREF(listAll);
                        return nullptr;
                    }
                }
            }
            return listAll;
            // END of custom code block [file: shibokenmodule.cpp (getallvalidwrappers)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_getCppPointer(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.getCppPointer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: getCppPointer(PyObject*)->PySequence*
    if (true) {
        overloadId = 0; // getCppPointer(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getCppPointer(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (getcpppointer)]
            if (Shiboken::Object::checkType(pyArg)) {
                std::vector<void*> ptrs = Shiboken::Object::cppPointers(reinterpret_cast<SbkObject *>(pyArg));
                pyResult = PyTuple_New(ptrs.size());
                for (std::size_t i = 0; i < ptrs.size(); ++i)
                    PyTuple_SET_ITEM(pyResult, i, PyLong_FromVoidPtr(ptrs[i]));
            } else {
                PyErr_SetString(PyExc_TypeError, "You need a shiboken-based type.");
            }
            // END of custom code block [file: shibokenmodule.cpp (getcpppointer)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_invalidate(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.invalidate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: invalidate(PyObject*)
    if (true) {
        overloadId = 0; // invalidate(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // invalidate(PyObject*)
            // Begin code injection
            Shiboken::Object::invalidate(pyArg);
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *SbkShibokenModule_isValid(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: isValid(PyObject*)->bool
    if (true) {
        overloadId = 0; // isValid(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (isvalid)]
            bool isValid = Shiboken::Object::isValid(pyArg, false);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &isValid);
            // END of custom code block [file: shibokenmodule.cpp (isvalid)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_ownedByPython(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.ownedByPython";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: ownedByPython(PyObject*)->bool
    if (true) {
        overloadId = 0; // ownedByPython(PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // ownedByPython(PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (ownedbypython)]
            if (Shiboken::Object::checkType(pyArg)) {
                bool hasOwnership = Shiboken::Object::hasOwnership(reinterpret_cast<SbkObject *>(pyArg));
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &hasOwnership);
            } else {
                PyErr_SetString(PyExc_TypeError, "You need a shiboken-based type.");
            }
            // END of custom code block [file: shibokenmodule.cpp (ownedbypython)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *SbkShibokenModule_wrapInstance(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "Shiboken.wrapInstance";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "wrapInstance", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: wrapInstance(size_t,PyTypeObject)->PyObject*
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<size_t>(), (pyArgs[0])))
        && PyType_Check(pyArgs[1])) {
        overloadId = 0; // wrapInstance(size_t,PyTypeObject)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        size_t cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        SBK_UNUSED(cppArg0)

        if (Shiboken::Errors::occurred() == nullptr) {
            // wrapInstance(size_t,PyTypeObject)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: shibokenmodule.cpp (wrapinstance)]
            auto *pyType = reinterpret_cast<PyTypeObject *>(pyArgs[1]);
            if (Shiboken::ObjectType::checkType(pyType)) {
                auto *ptr = reinterpret_cast<void *>(cppArg0);
                if (auto *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(ptr)) {
                    Py_INCREF(wrapper);
                    pyResult = reinterpret_cast<PyObject *>(wrapper);
                } else {
                    pyResult = Shiboken::Object::newObject(pyType, ptr, false, true);
                }
            } else {
                PyErr_SetString(PyExc_TypeError, "You need a shiboken-based type.");
            }
            // END of custom code block [file: shibokenmodule.cpp (wrapinstance)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static PyMethodDef Shiboken_methods[] = {
    {"createdByPython", reinterpret_cast<PyCFunction>(SbkShibokenModule_createdByPython), METH_O, nullptr},
    {"delete", reinterpret_cast<PyCFunction>(SbkShibokenModule_delete), METH_O, nullptr},
    {"disassembleFrame", reinterpret_cast<PyCFunction>(SbkShibokenModule_disassembleFrame), METH_O, nullptr},
    {"dump", reinterpret_cast<PyCFunction>(SbkShibokenModule_dump), METH_O, nullptr},
    {"dumpTypeGraph", reinterpret_cast<PyCFunction>(SbkShibokenModule_dumpTypeGraph), METH_O, nullptr},
    {"dumpWrapperMap", reinterpret_cast<PyCFunction>(SbkShibokenModule_dumpWrapperMap), METH_NOARGS, nullptr},
    {"getAllValidWrappers", reinterpret_cast<PyCFunction>(SbkShibokenModule_getAllValidWrappers), METH_NOARGS, nullptr},
    {"getCppPointer", reinterpret_cast<PyCFunction>(SbkShibokenModule_getCppPointer), METH_O, nullptr},
    {"invalidate", reinterpret_cast<PyCFunction>(SbkShibokenModule_invalidate), METH_O, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(SbkShibokenModule_isValid), METH_O, nullptr},
    {"ownedByPython", reinterpret_cast<PyCFunction>(SbkShibokenModule_ownedByPython), METH_O, nullptr},
    {"wrapInstance", reinterpret_cast<PyCFunction>(SbkShibokenModule_wrapInstance), METH_VARARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Classes initialization functions ------------------------------------------------------------


// Module initialization ------------------------------------------------------------
static struct PyModuleDef moduledef = {
    /* m_base     */ PyModuleDef_HEAD_INIT,
    /* m_name     */ "Shiboken",
    /* m_doc      */ nullptr,
    /* m_size     */ -1,
    /* m_methods  */ Shiboken_methods,
    /* m_reload   */ nullptr,
    /* m_traverse */ nullptr,
    /* m_clear    */ nullptr,
    /* m_free     */ nullptr
};

// The signatures string for the global functions.
// Multiple signatures have their index "n:" in front.
static const char *Shiboken_SignatureStrings[] = {
    "Shiboken.createdByPython(arg__1:PyObject)->bool",
    "Shiboken.delete(arg__1:PyObject)",
    "Shiboken.disassembleFrame(arg__1:PyObject)->PyObject",
    "Shiboken.dump(arg__1:PyObject)->char*",
    "Shiboken.dumpTypeGraph(fileName:char*)->bool",
    "Shiboken.dumpWrapperMap()",
    "Shiboken.getAllValidWrappers()->PySequence",
    "Shiboken.getCppPointer(arg__1:PyObject)->PySequence",
    "Shiboken.invalidate(arg__1:PyObject)",
    "Shiboken.isValid(arg__1:PyObject)->bool",
    "Shiboken.ownedByPython(arg__1:PyObject)->bool",
    "Shiboken.wrapInstance(arg__1:size_t,arg__2:PyTypeObject)->PyObject",
    nullptr}; // Sentinel

static void initInheritance()
{
    auto &bm = Shiboken::BindingManager::instance();
    SBK_UNUSED(bm)
}

extern "C" LIBSHIBOKEN_EXPORT PyObject *PyInit_Shiboken()
{
    if (SbkShibokenModuleObject != nullptr)
        return SbkShibokenModuleObject;
    // Create an array of primitive type converters for the current module.
    static SbkConverter *sbkConverters[SBK_Shiboken_CONVERTERS_IDX_COUNT];
    SbkShibokenTypeConverters = sbkConverters;

    PyObject *module = Shiboken::Module::create("Shiboken", &moduledef);

    // Make module available from global scope
    SbkShibokenModuleObject = module;

    // Initialize classes in the type system
    // Register primitive types converters.

    Shiboken::Module::registerTypeConverters(module, SbkShibokenTypeConverters);

    initInheritance();

    if (Shiboken::Errors::occurred() != nullptr) {
        PyErr_Print();
        Py_FatalError("can't initialize module Shiboken");
    }
    // Begin code injection
    // ========================================================================
    // START of custom code block [file: shibokenmodule.cpp (init)]
    // Add __version__ and __version_info__ attributes to the module
    PyObject* version = PyTuple_New(5);
    PyTuple_SET_ITEM(version, 0, PyLong_FromLong(SHIBOKEN_MAJOR_VERSION));
    PyTuple_SET_ITEM(version, 1, PyLong_FromLong(SHIBOKEN_MINOR_VERSION));
    PyTuple_SET_ITEM(version, 2, PyLong_FromLong(SHIBOKEN_MICRO_VERSION));
    PyTuple_SET_ITEM(version, 3, Shiboken::String::fromCString(SHIBOKEN_RELEASE_LEVEL));
    PyTuple_SET_ITEM(version, 4, PyLong_FromLong(SHIBOKEN_SERIAL));
    PyModule_AddObject(module, "__version_info__", version);
    PyModule_AddStringConstant(module, "__version__", SHIBOKEN_VERSION);
    VoidPtr::addVoidPtrToModule(module);
    Shiboken::initShibokenSupport(module);
    // END of custom code block [file: shibokenmodule.cpp (init)]
    // ========================================================================
    // End of code injection

    FinishSignatureInitialization(module, Shiboken_SignatureStrings);

    return module;
}
